#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <fcntl.h>
#include <errno.h>

#include "loadcfg.h"

/* Load the proper segment from the configuration file. */
int
LoadConfig (struct CFG *prg_cfg)
{
  FILE *Fin;
  char *p0, *p, *Value, *cn;
  char Name[BUFSIZ];
  struct CFG *pcfg;
  int rez = 0;

  Fin = fopen (CONFIG_FILE, "r");
  if (Fin == NULL)
	return -1;

#define Isspace(c) (c == ' ' || c == '\t')

  while( (p0=fgets(Name, sizeof(Name), Fin)) != NULL) {
	p = strpbrk(p0, "#\r\n");
	if(p)
		*p = '\0';
	while(Isspace(*p0))
		p0++;
	if(*p0 == '\0')
		continue;
	p = p0;
	cn = Name;
	/* Remove (paste) spaces form filed name */
  loop:
	while(*p != '\0' && !Isspace(*p) && *p != '=')
		*cn++ = *p++;
	if(Isspace(*p)) {
		p++;
		goto loop;
	}
	if(*p == '\0')
		continue;
	/* *p == '=' */
	*cn = '\0';
	do p++; while(Isspace(*p));
	if(*p == '\0') {
		/* Field =<empty> */
		continue;
	}
	Value = p;
	cn = p + strlen(p) - 1;
	while(cn > p && Isspace(*cn))
		*cn-- = '\0';   // remove <space>: Field=Value<space>#remark
	/* but Value can have spaces */

	for(pcfg = prg_cfg; pcfg->name != NULL; pcfg++) {
		if (strcasecmp (Name, pcfg->name) == 0) {
			Value = strdup(Value);
			if(Value)  {
				pcfg->value = Value;
				rez++;
			}
		}
	}
  }
  fclose(Fin);
  return rez;
}

/*
  :

key=   int_32

time_t
int_32 -   (24 )
*/

int open_db_writer (const char *database_name)
{
  int fd;

  /*     */
  fd = open(database_name, O_RDWR | O_CREAT, 0666);
  if(fd < 0)
	return fd;
  while(flock(fd, LOCK_EX) < 0 && errno == EINTR)
	;
  return fd;
}

int open_db_reader (const char *database_name)
{
  int fd;

  /*     */
  fd = open(database_name, O_RDONLY, 0666);
  if(fd < 0)
	return fd;
  while(flock(fd, LOCK_SH) < 0 && errno == EINTR)
	;
  return fd;
}
